package sun.management.snmp.jvminstr;

import com.sun.jmx.snmp.SnmpStatusException;
import java.lang.management.ManagementFactory;
import java.lang.management.ClassLoadingMXBean;
import javax.management.MBeanServer;
import com.sun.jmx.snmp.agent.SnmpMib;
import sun.management.snmp.jvmmib.EnumJvmClassesVerboseLevel;
import sun.management.snmp.jvmmib.JvmClassLoadingMBean;

public class JvmClassLoadingImpl implements JvmClassLoadingMBean
{
    static final EnumJvmClassesVerboseLevel JvmClassesVerboseLevelVerbose;
    static final EnumJvmClassesVerboseLevel JvmClassesVerboseLevelSilent;
    
    public JvmClassLoadingImpl(SnmpMib snmpMib) {
    }
    
    public JvmClassLoadingImpl(SnmpMib snmpMib, MBeanServer mBeanServer) {
    }
    
    static ClassLoadingMXBean getClassLoadingMXBean() {
        return ManagementFactory.getClassLoadingMXBean();
    }
    
    public EnumJvmClassesVerboseLevel getJvmClassesVerboseLevel() throws SnmpStatusException {
        if (getClassLoadingMXBean().isVerbose()) {
            return JvmClassLoadingImpl.JvmClassesVerboseLevelVerbose;
        }
        return JvmClassLoadingImpl.JvmClassesVerboseLevelSilent;
    }
    
    public void setJvmClassesVerboseLevel(EnumJvmClassesVerboseLevel enumJvmClassesVerboseLevel) throws SnmpStatusException {
        int verbose;
        if (JvmClassLoadingImpl.JvmClassesVerboseLevelVerbose.equals(enumJvmClassesVerboseLevel)) {
            verbose = true;
        }
        else if (JvmClassLoadingImpl.JvmClassesVerboseLevelSilent.equals(enumJvmClassesVerboseLevel)) {
            verbose = false;
        }
        else {
            throw new SnmpStatusException(10);
        }
        getClassLoadingMXBean().setVerbose((boolean)verbose);
    }
    
    public void checkJvmClassesVerboseLevel(EnumJvmClassesVerboseLevel enumJvmClassesVerboseLevel) throws SnmpStatusException {
        if (JvmClassLoadingImpl.JvmClassesVerboseLevelVerbose.equals(enumJvmClassesVerboseLevel)) {
            return;
        }
        if (JvmClassLoadingImpl.JvmClassesVerboseLevelSilent.equals(enumJvmClassesVerboseLevel)) {
            return;
        }
        throw new SnmpStatusException(10);
    }
    
    public Long getJvmClassesUnloadedCount() throws SnmpStatusException {
        return new Long(getClassLoadingMXBean().getUnloadedClassCount());
    }
    
    public Long getJvmClassesTotalLoadedCount() throws SnmpStatusException {
        return new Long(getClassLoadingMXBean().getTotalLoadedClassCount());
    }
    
    public Long getJvmClassesLoadedCount() throws SnmpStatusException {
        return new Long((long)getClassLoadingMXBean().getLoadedClassCount());
    }
    
    static {
        JvmClassesVerboseLevelVerbose = new EnumJvmClassesVerboseLevel("verbose");
        JvmClassesVerboseLevelSilent = new EnumJvmClassesVerboseLevel("silent");
    }
}
